(game-module "june44"
  (blurb "Battalion-level version of Normandy invasion")
  )

(set see-all true) ; for debugging

;;; (the short-name should be long-name...)

;;; Non-motorized infantry.

(unit-type inf (long-name "infantry") (image-name "infantry"))
(unit-type inf-bicycle (long-name "bicycle infantry"))
(unit-type inf-para (long-name "parachute infantry") (possible-sides "allied"))
(unit-type inf-glider (long-name "glider infantry") (possible-sides "allied"))
(unit-type inf-sec (long-name "security") (possible-sides "allied"))
(unit-type inf-ranger (long-name "rangers") (possible-sides "allied"))
(unit-type inf-cmdo (long-name "commando") (possible-sides "allied"))
(unit-type inf-fusil (long-name "fusilier") (possible-sides "german"))
(unit-type inf-ost (long-name "ost") (possible-sides "german"))
(unit-type inf-pion (long-name "pioniere") (possible-sides "german"))

(define non-mot-inf-batt-types
  (inf inf-bicycle inf-para inf-glider inf-ranger inf-cmdo inf-fusil inf-ost inf-pion))

(define non-mot-inf-co-types (inf-sec))

(define non-mot-inf-types
  (inf inf-bicycle inf-para inf-glider inf-sec
  inf-ranger inf-cmdo inf-fusil inf-ost inf-pion))

(add non-mot-inf-types image-name "infantry") ; for now

(add non-mot-inf-types acp-per-turn 4)
(add non-mot-inf-types speed 4)

;;; Motorized infantry.

(unit-type inf-mot (long-name "motorized infantry"))
(unit-type inf-heavy (long-name "heavy weapon infantry"))
(unit-type inf-mg-co (long-name "machinegun company"))
(unit-type inf-mot-sec)
(unit-type inf-recon (possible-sides "allied"))
(unit-type inf-fsj (possible-sides "german"))
(unit-type inf-mot-pion (possible-sides "german"))
(unit-type inf-mech-cav)

(define mot-inf-batt-types (inf-mot inf-fsj inf-recon))

(define mot-inf-co-types
  (inf-heavy inf-mg-co inf-mot-sec inf-recon inf-mot-pion inf-mech-cav))

(define mot-inf-types
  (inf-mot inf-heavy inf-mg-co inf-mot-sec inf-fsj inf-mot-pion inf-mech-cav))

(add mot-inf-types image-name "infantry") ; for now

;;; Tracked infantry.

(unit-type inf-armor (long-name "armored infantry"))
(unit-type inf-pz-pion (long-name "Panzer pioniere") (possible-sides "german"))
(unit-type inf-armor-recon (long-name "armored recon") (possible-sides "german"))
(unit-type inf-lw-recon (long-name "Luftwaffe recon") (possible-sides "german"))

(define tracked-inf-types (inf-armor inf-pz-pion inf-armor-recon inf-lw-recon))

(add tracked-inf-types image-name "infantry") ; for now

(unit-type arty-cd-cased (long-name "casemated coastal artillery"))
(unit-type arty-cd-open (long-name "open coastal artillery"))
(unit-type arty-cd-rr (long-name "railroad coastal artillery"))
(unit-type arty-horse (long-name "horse-drawn artillery battalion"))
(unit-type arty-horse-bty (long-name "horse-drawn artillery battery"))
(unit-type arty-para (long-name "parachute artillery") (possible-sides "allied"))
(unit-type arty-glider (long-name "glider artillery") (possible-sides "allied"))
(unit-type arty-rr (long-name "railroad artillery"))

(define german-non-mot-arty
  (arty-cd-cased arty-cd-open arty-cd-rr))

(add german-non-mot-arty possible-sides "german")

(define non-mot-arty
  (arty-cd-cased arty-cd-open arty-cd-rr arty-horse arty-horse-bty
   arty-para arty-glider arty-rr))

(add non-mot-arty image-name "field-gun")

(add non-mot-arty acp-per-turn 4)
(add non-mot-arty speed 4)

(add non-mot-arty acp-to-fire 1)
(add non-mot-arty range   6)

(add german-non-mot-arty acp-per-turn 1)
(add german-non-mot-arty speed 0)

(add german-non-mot-arty range   (9 8 15))

(unit-type arty-group (long-name "artillery group") (possible-sides "allied"))
(unit-type arty-hq (long-name "HQ/artillery") (possible-sides "allied"))
(unit-type arty-towed (long-name "towed artillery"))
(unit-type flak (possible-sides "german"))
(unit-type flak-bty (possible-sides "german"))
(unit-type at)
(unit-type nebel (possible-sides "german"))
(unit-type mortar)
(unit-type mortar4.2 (possible-sides "allied"))
(unit-type fortress-batt)

(define mot-arty
  (arty-group arty-hq arty-towed flak flak-bty
   at nebel mortar mortar4.2 fortress-batt))

(add mot-arty image-name "field-gun")

(add mot-arty acp-per-turn 8)
(add mot-arty speed 8)

(add mot-arty acp-to-fire 1)
(add mot-arty range   6)

(unit-type arty-armor)
(unit-type nebel-bty (possible-sides "german"))
(unit-type arty-hq-armor (long-name "HQ/artillery, tracked") (possible-sides "allied"))
(unit-type sp-at (long-name "self-propelled anti-tank battalion"))
(unit-type sp-at-co (long-name "self-propelled anti-tank company"))

(define tracked-arty (arty-armor nebel-bty arty-hq-armor sp-at sp-at-co))

(add tracked-arty image-name "field-gun")

(add tracked-arty acp-per-turn 6)
(add tracked-arty speed 6)

(add tracked-arty acp-to-fire 1)
(add tracked-arty range   (6 3 6 1 1))

(unit-type tank (long-name "tank battalion"))
(unit-type ag (long-name "assault gun battalion"))
(unit-type tank-co (long-name "tank company"))
(unit-type ag-co (long-name "assault gun company"))
(unit-type croc-co (long-name "crocodile company"))

(define armor-types (tank ag tank-co ag-co croc-co))

(add armor-types image-name "armor")

(unit-type fort (image-name "fortress"))
(unit-type fortification (image-name "fortress"))
(unit-type coast-strongpoint (image-name "fortress"))

;; Headquarters types.

(unit-type hq-nebel-brg (long-name "nebelwerfer brigade HQ"))
(unit-type hq-flak-reg (long-name "sturmflak regiment HQ"))

(unit-type hq-inf-div (long-name "inf div HQ"))
(unit-type hq-mot-div (long-name "mot inf div HQ"))
(unit-type hq-air-div (long-name "air div HQ"))
(unit-type hq-gren-div (long-name "panzergrenadier div HQ"))
(unit-type hq-armor-div (long-name "armor div HQ"))

(unit-type hq-inf-corps (long-name "infantry corps HQ"))
(unit-type hq-flak-korps (long-name "sturmflak korps HQ"))
(unit-type hq-pz-korps (long-name "panzer korps HQ"))
(unit-type hq-fsj-korps (long-name "fallschirmjaeger korps HQ"))

(define german-hq-types
  (hq-nebel-brg hq-flak-reg hq-gren-div hq-flak-korps hq-pz-korps hq-fsj-korps))

(add german-hq-types possible-sides "german")

(define allied-hq-types
  (hq-inf-div hq-mot-div hq-air-div hq-armor-div hq-inf-corps))

(add allied-hq-types possible-sides "allied")

(define hq-types
  (hq-nebel-brg hq-flak-reg hq-inf-div hq-mot-div hq-air-div hq-gren-div hq-armor-div
  hq-inf-corps hq-flak-korps hq-pz-korps hq-fsj-korps))

(add hq-types image-name "flag")

(add hq-types acp-per-turn 6)
(add hq-types speed 6)

;;; Supply-related units.

(unit-type mulberry (possible-sides "allied"))
(unit-type supply-depot)

;;; Trains.

(unit-type train (possible-sides "german"))

;;; Ships.

(unit-type transport (image-name "ap"))
(unit-type destroyer (image-name "dd"))
(unit-type cruiser (image-name "ca"))
(unit-type battleship (image-name "bb"))

(define ship-types (transport destroyer cruiser battleship))

(add ship-types possible-sides "allied")

(add ship-types acp-per-turn 2)
(add ship-types speed 120)

(add (destroyer cruiser battleship) acp-to-fire 1)
(add (destroyer cruiser battleship) range   (6 8 12))

;;; Aircraft.

(unit-type fighter-bomber (image-name "1e"))
(unit-type light-bomber (image-name "4e"))
(unit-type medium-bomber (image-name "4e"))
(unit-type heavy-bomber (image-name "4e"))

(define aircraft (fighter-bomber light-bomber medium-bomber heavy-bomber))

(add aircraft possible-sides "allied")

(add aircraft acp-per-turn 2)
(add aircraft speed 120)

;;; Places.

(unit-type village (image-name "town20"))
(unit-type town (image-name "city18"))

(define places (village town))

(add places see-always true)

(define i inf)
(define a tank)
(define * village)
(define @ town)

;;; Materials

(material-type fuel)

;;; Terrain and its properties.

(terrain-type sea (color "dodgerblue") (char ".")
  (occurrence 10))
(terrain-type clear (color "white") (char "+")
  (occurrence 60))
(terrain-type bocage (color "green") (char "#")
  (occurrence 20))
(terrain-type hill (color "sienna") (image-name "mountains") (char "^")
  (occurrence 1))
(terrain-type forest (color "forest green") (char "%")
  (occurrence 8))
(terrain-type swamp (color "yellow green")
  )
(terrain-type flooded (color "light blue")
  )
(terrain-type city (color "gray") (image-name "urban") (char "*")
  (occurrence 1))
(terrain-type river (color "blue")
  (subtype border))
(terrain-type road (color "gray")
  (subtype connection))
(terrain-type sec-road (color "gray")
  (subtype connection))
(terrain-type railroad (color "black")
  (subtype connection))

(define land (clear bocage hill forest swamp flooded city))

(add t* elevation-min 0)
(add t* elevation-max 100)
(add (sea swamp) elevation-max 0) 

;;; Static relationships.

(table vanishes-on
  (non-mot-inf-types sea true)
  (mot-inf-types sea true)
  (non-mot-arty sea true)
  (mot-arty sea true)
  (tracked-arty sea true)
  (armor-types sea true)
  (hq-types sea true)
  (ship-types land true)
  )

;; A cell has a capacity for basically six companies or two battalions.

(add t* capacity 6)

(table unit-size-in-terrain
  (non-mot-inf-types t* 3)
  (mot-inf-types t* 3)
  (non-mot-arty t* 1)
  (mot-arty t* 1)
  (tracked-arty t* 1)
  (sp-at t* 3)
  (armor-types t* 1)
  ((tank ag) t* 2)
  (hq-types t* 1)
  )

;;; Action parameters.

;;; Movement parameters.

(table mp-to-leave-terrain
  (u* t* 0)
  )

(table mp-to-enter-terrain
  (u* t* 1)
  (u* swamp 2)
  (u* flooded 2)
  ;; should be for all motorized types
  (mot-inf-types t* 2)
  (mot-inf-types city 1)
  (mot-arty t* 2)
  (mot-arty city 1)
  ;; should be for all tracked types
  (armor-types (bocage hill forest) 2)
  (armor-types swamp 4)
  (armor-types flooded 3)
  ;; Extra cost to cross rivers
  (u* river 1)
  (mot-inf-types river 4)
  (mot-arty river 4)
  (armor-types river 4) 
  )

;;; Combat parameters.

(table hit-chance
  (u* u* 50)
)

(table damage
  (u* u* 1)
)

;;; Capture.

(table capture-chance
  ((i a) (* @) 100)
)

;;; Random game synthesis (for testing mostly, will usually use fixed map).

(synthesis-methods set
  make-random-terrain make-countries make-independent-units make-roads)

;; need a French name generator for villages.
;(add village independent-density 1000)
;; (or set all villages to be German?)

(set country-radius-min 8)

(add sea country-terrain-min 4)

(add sea country-terrain-max 10)

;; One of everything.
(add u* start-with 1)
;(add (inf tank town) start-with 1)

(table favored-terrain
  (u* t* 100)
  (u* sea 0)
  (ship-types t* 0)
  (ship-types sea 100)
)

;(add (clear bocage) road-density 1)

;;; Scenario fillins.

;;; Entire Normandy area is known.

;;; Getting the dates right.

(set calendar ("usual" "day"))

(set initial-date "6 Jun 1944")

(world 360 (day-length 1))

;;; The usual sides.

(side-library set
  ((name "Allies") (adjective "Allied") (class "allied")
   (color-scheme "blue") (emblem-name "white-star"))
  ((name "Germany") (adjective "German") (class "german")
   (color-scheme "black") (emblem-name "german-cross"))
)

;(independent-units (emblem-name "???"))

(game-module (notes (
  "This is an extremely detailed game about the D-Day invasion of Normandy and"
  "the months of slugfest that followed."
  )))

(game-module (design-notes (
  "The basic map scale is 2km/hex."
  )))

