#include "config.h"
#include "misc.h"
#include "dir.h"
#include "lisp.h"

#include "module.h"
#include "game.h"
#include "player.h"
#include "side.h"
#include "unit.h"
#include "world.h"
#include "score.h"
#include "history.h"

#include "ai.h"

enum keywords {

#undef  DEF_KWD
#define DEF_KWD(CODE,name,value)  CODE,

#include "keyword.def"

    LAST_KEYWORD
};

/* As good a place as any... */

typedef struct a_helpnode {
    char *key;
    int (*fn)();
    int arg;
    char *text;
    int textend;
    int textsize;
    struct a_helpnode *prev;
    struct a_helpnode *next;
} HelpNode;

extern HelpNode *firsthelpnode;
void create_game_help_nodes();
HelpNode *add_help_node();
HelpNode *find_help_node();
char *get_help_text();

/* Declarations of interface functions called from the kernel. */

/* Every interface must implement these in some way. */

char *savefile_name();
char *newsfile_name();
FILE *open_library_file();
FILE *open_explicit_file();

int announce_read_progress();
int announce_lengthy_process();
int announce_progress();
int finish_lengthy_process();

Player *add_default_player();

int update_turn_display();
int update_action_display();
int update_action_result_display();
int update_clock_display();
int update_side_display();
int update_unit_display();
int update_cell_display();
int update_everything();
int draw_blast();
int flush_display_buffers();

int init_warning();
int init_error();
int abort_init();
int run_warning();
int run_error();

/* temp hacks */

#define inside_world inside_area
#define search_area search_around
