/* Copyright (c) 1991, 1992  Stanley T. Shebs. */
/* This program may be used, copied, modified, and redistributed freely */
/* for noncommercial purposes, so long as this notice remains intact. */

/* A road generation method that connects specified types of units
   and favors specified types of terrain. */

/* (should add some favoring of nearby rather than totally random units?) */

/* Assumes only one connection type, should go for a "road type" if
   one can be recognized. */

#include "conq.h"

static Unit *otherunit;

int roadtype;

make_roads()
{
#if 0
    int doanyroads = FALSE, doroads[MAXUTYPES];
    int t, u1, u2;
    Unit *unit1, *unit2;
    Side *loopside1, *loopside2;
    int i = 0, numroads = 0;

    roadtype = NONTTYPE;
    for_all_terrain_types(t) {
	if (t_is_connection(t)
    if (numconntypes <= 0 || connections_defined()) return;
    /* Don't run if road chance always zero. */
    for_all_unit_types(u1) doroads[u1] = FALSE;
    for_all_unit_types(u1) {
	for_all_unit_types(u2) {
	    if (uu_road_chance(u1, u2) > 0) {
		doroads[u1] = TRUE;
		doanyroads = TRUE;
		break;
	    }
	}
    }
    if (!doanyroads) return;
    /* Now we're ready to get down to work. */
    allocate_area_connections();
    roadtype = theconnectiontype;
    announce_lengthy_process("Laying down roads");
    announce_progress(1);
    /* should be able to announce progress by guessing at number of roads. */
    for_all_units(loopside1, unit1) {
	if (doroads[unit1->type]) {
	    for_all_units(loopside2, unit2) {
		if (unit1 != unit2
		    && probability(uu_road_chance(unit1->type, unit2->type))) {
		    lay_connecting_road(unit1, unit2);
		}
	    }
	}
    }
    finish_lengthy_process();
#endif
}

/* Given that a road is wanted between the two given units, attempt to
   route it favorably. */

lay_connecting_road(unit1, unit2)
Unit *unit1, *unit2;
{
    lay_road_between(unit1->x, unit1->y, unit2->x, unit2->y);
}

/* Lay down a single bit of road, tending to choose directions with more
   favorable underlying terrain and merging with already-existing roads. */

lay_road_segment(x, y, d, choice, numchoices)
int x, y, d, choice, numchoices;
{
    int d2;

    if (probability(tt_road_into_chance(roadtype, terrain_at(x, y)))) {
	set_connection_at(x, y, d, roadtype);
	/* See if there any roads leading out of the next cell. */
	for_all_directions(d2) {
	    if (opposite_dir(d) != d2
		&& connection_at(wrap(x+dirx[d]), y+diry[d], d2) == roadtype) {
		/* Joined up with another road - stop. */
		return -1;
	    }
	}
	/* Keep going along path. */
	return 1;
    } else {
	if (choice < numchoices) {
	    /* Go back and try the next direction. */
	    return 0;
	} else {
	    /* No more choices, give up. */
	    return -1;
	}
    }
}

/* Do the whole path. */

lay_road_between(x1, y1, x2, y2)
int x1, y1, x2, y2;
{
    apply_to_path(x1, y1, x2, y2, lay_road_segment, FALSE);
}

can_be_connection_on(t1, t2)
int t1, t2;
{
    return 1 /* (t_road_density(t2) > 0) */;
}
